#include<iostream>
#include<vector>
#include<cstdio>
using namespace std;

const int N=500010;
vector<int>e[N];
int ll[5010][5010];
int dep[N],f[N][20];
int n,q;

void gdep(int u,int fa)
{
	dep[u]=dep[fa]+1;
	f[u][0]=fa;
	for(int i=1;i<20;i++)f[u][i]=f[f[u][i-1]][i-1];
	for(int i=0;i<e[u].size();i++)
		if(e[u][i]!=fa)
			gdep(e[u][i],u);
}
int lca(int x,int y)
{
	if(dep[x]<dep[y])swap(x,y);
	for(int i=19;i>=0;i--)if(dep[f[x][i]]>=dep[y])x=f[x][i];
	if(x==y)return x;
	for(int i=19;i>=0;i--)if(f[x][i]!=f[y][i])x=f[x][i],y=f[y][i];
	return f[x][0];
}

int main()
{
	freopen("query.in","r",stdin);freopen("query.out","w",stdout);
	ios::sync_with_stdio(0),cin.tie(0);
	cin>>n;
	int u,v;
	for(int i=1;i<n;i++)
		cin>>u>>v,e[u].push_back(v),e[v].push_back(u);
	gdep(1,0);
	int q,l,r,k;
		cin>>q;
	if(n<=5000)
	{
		for(int i=1;i<=n;i++)
			for(int j=i;j<=n;j++)
				ll[i][j]=(i==j?i:lca(ll[i][j-1],j));
		while(q--)
		{
			cin>>l>>r>>k;
			int ans=0;
			for(int len=k;len<=r-l+1;len++)
				for(int i=l;i+len-1<=r;i++)
					ans=max(ans,dep[ll[i][i+len-1]]);
			cout<<ans<<'\n';
		}
	}
	else while(q--)cin>>l>>r>>k,cout<<1<<'\n';
	return 0;
}
